using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
//using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Tekla.Structures.Model;
using Tekla.Structures.Model.UI;
using Tekla.Structures;

namespace Tekla.Technology.Akit.UserScript
{
    public class FormGUID : System.Windows.Forms.Form
    { 
        private System.Windows.Forms.TextBox GUID;
        private System.Windows.Forms.Button buttonSelect;
        private System.Windows.Forms.Button buttonDelete;
        private System.Windows.Forms.Label labelMO;

        private System.ComponentModel.IContainer components = null;

        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.GUID = new System.Windows.Forms.TextBox();
            this.buttonSelect = new System.Windows.Forms.Button();
            this.buttonDelete = new System.Windows.Forms.Button();
            this.labelMO = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // GUID
            // 
            this.GUID.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.GUID.Location = new System.Drawing.Point(7, 6);
            this.GUID.Name = "GUID";
            this.GUID.Size = new System.Drawing.Size(265, 20);
            this.GUID.TabIndex = 0;
            this.GUID.TextChanged += new System.EventHandler(this.GUID_TextChanged);
            // 
            // buttonSelect
            // 
            this.buttonSelect.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left)));
            this.buttonSelect.Location = new System.Drawing.Point(10, 65);
            this.buttonSelect.Name = "buttonSelect";
            this.buttonSelect.Size = new System.Drawing.Size(128, 23);
            this.buttonSelect.TabIndex = 1;
            this.buttonSelect.Text = "";
            this.buttonSelect.UseVisualStyleBackColor = true;
            this.buttonSelect.Click += new System.EventHandler(this.buttonSelect_Click);
            // 
            // buttonDelete
            // 
            this.buttonDelete.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.buttonDelete.Location = new System.Drawing.Point(143, 65);
            this.buttonDelete.Name = "buttonDelete";
            this.buttonDelete.Size = new System.Drawing.Size(128, 23);
            this.buttonDelete.TabIndex = 2;
            this.buttonDelete.Text = "";
            this.buttonDelete.UseVisualStyleBackColor = true;
            this.buttonDelete.Click += new System.EventHandler(this.buttonDelete_Click);
            // 
            // labelMO
            // 
            this.labelMO.AutoSize = true;
            this.labelMO.Location = new System.Drawing.Point(10, 36);
            this.labelMO.Name = "labelMO";
            this.labelMO.Size = new System.Drawing.Size(0, 13);
            this.labelMO.TabIndex = 3;
            // 
            // FormGUID
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(279, 97);
            this.Controls.Add(this.labelMO);
            this.Controls.Add(this.buttonDelete);
            this.Controls.Add(this.buttonSelect);
            this.Controls.Add(this.GUID);
            this.MinimumSize = new System.Drawing.Size(295, 135);
            this.Name = "FormGUID";
            this.Text = "GUID";
            this.TopMost = true;
            this.FormClosed += new System.Windows.Forms.FormClosedEventHandler(this.FormGUID_FormClosed);
            this.ResumeLayout(false);
            this.PerformLayout();

        }

 	Model M = new Model();
        Tekla.Structures.Model.ModelObject MO = null;

        public FormGUID()
        {
            InitializeComponent();
        }

        private void GUID_TextChanged(object sender, EventArgs e)
        {
            String GUIDs = GUID.Text;
            if (GUIDs != "")
            {
                Identifier OI = M.GetIdentifierByGUID(GUIDs);
                if (OI != null)
                {
                    MO = M.SelectModelObject(OI);
                    labelMO.Text = MO.ToString();
                }
                else
                {
                    MO = null;
                    labelMO.Text = "  !!!";
                }
            }
            
        }

        private void buttonSelect_Click(object sender, EventArgs e)
        {
            if (MO != null)
            {
                Tekla.Structures.Model.UI.ModelObjectSelector MS = new Tekla.Structures.Model.UI.ModelObjectSelector();
                ArrayList AS = new ArrayList();
                AS.Add(MO);
                MS.Select(AS);
                Tekla.Structures.ModelInternal.Operation.dotStartAction("ZoomToSelected", "");
            }
        }

        private void buttonDelete_Click(object sender, EventArgs e)
        {
            if (MO != null)
            {
                if (MessageBox.Show(" ? " + GUID.Text, "", MessageBoxButtons.YesNo) == System.Windows.Forms.DialogResult.Yes)
                {
                    int Bl = 0;
                    MO.GetUserProperty("OBJECT_LOCKED",ref Bl);
                    if (Bl == 1)
                    {
                        if (MessageBox.Show(" !!!   ?", "", MessageBoxButtons.YesNo) == System.Windows.Forms.DialogResult.Yes)
                        {
                            MO.SetUserProperty("OBJECT_LOCKED", 0);
                        }
                    }
                    MO.Delete();
                    M.CommitChanges();
                }

            }
        }
        
        private void FormGUID_FormClosed(object sender, FormClosedEventArgs e)
        {
            Application.Exit();
        }
       
    }
    
    public class Script
    {
        public static void Run(Tekla.Technology.Akit.IScript akit)
        {
            akit.ValueChange("main_frame", "sel_all", "1");
            akit.ValueChange("main_frame", "sel_custom_objects", "1");
            akit.ValueChange("main_frame", "sel_filter", "standard");
            Application.EnableVisualStyles();
            Application.Run(new FormGUID());
            
        }
    }

}